FORMAT: 1A
HOST: https://app.detrack.com/api/v2

# Detrack API V2

This describes the resources that make up the official Detrack REST API v2. If you have any problems or requests please contact Detrack support.

## Schema

All timestamps return in ISO 8601 format:

`YYYY-MM-DDTHH:MM:SSZ`

## Client Errors

These are the possible error statuses:

+ Status `400` - Bad request. E.g. Malformed JSON.
+ Status `401` - Unauthorized.
+ Status `403` - Forbidden. You do not the permission to make the request.
+ Status `404` - Record not found.
+ Status `422` - Failed to process request because of validation error.
+ Status `429` - Exceeded rate limit.

## API key

When using API key, please set the header X-API-KEY with the key.

X-API-KEY: 9943520c80ee2aaad2cc80c29bdfb298e85feed021ef0328

## Rate Limiting

The rate limit allows up to 60 requests per minute. The server will response with status 429 (too many requests) when rate limit exceeded.

## Group Jobs

## Job (object)

Attributes

+ `type` (string) Detrack Job Type. Must be `Delivery` / `Collection`.
+ `primary_job_status` (string) Primary job status.
+ `open_to_marketplace` (string) Open to marketplace.
+ `marketplace_offer` (string) Marketplace offer.
+ `do_number` (string required) D.O No.
+ `date` (date required) Date.
+ `start_date` (date) Start date.
+ `status` (string) Job Status.
+ `job_release_time` (time) Job release time.
+ `job_time` (string) Job time.
+ `job_received_date` (date) Job received date.
+ `tracking_number` (string) Tracking number.
+ `order_number` (string) Order number.
+ `job_type` (string) Job type.
+ `job_sequence` (string) Job order.
+ `job_fee` (string) Job fee.
+ `address_lat` (string) Address lat.
+ `address_lng` (string) Address lng.
+ `address` (string required) Address.
+ `company_name` (string) Address company.
+ `address_1` (string) Address 1.
+ `address_2` (string) Address 2.
+ `address_3` (string) Address 3.
+ `postal_code` (string) Postal code.
+ `city` (string) City.
+ `state` (string) State.
+ `country` (string) Country.
+ `billing_address` (string) Billing address.
+ `deliver_to_collect_from` (string) Contact first name.
+ `last_name` (string) Contact last name.
+ `phone_number` (string) Contact phone.
+ `sender_phone_number` (string) Sender phone.
+ `fax_number` (string) Fax.
+ `instructions` (string) Instructions.
+ `assign_to` (string) Assign to.
+ `notify_email` (string) Notify email.
+ `webhook_url` (string) Webhook url.
+ `zone` (string) Zone.
+ `customer` (string) Customer.
+ `account_number` (string) Account number.
+ `job_owner` (string) Owner name.
+ `invoice_number` (string) Invoice number.
+ `invoice_amount` (string) Invoice amount.
+ `payment_mode` (string) Payment mode.
+ `payment_amount` (float) Payment amount.
+ `group_id` (string) Id of group that the job belongs to.
+ `group_name` (string) Group name.
+ `vendor_name` (string) Vendor name.
+ `source` (string) Source.
+ `weight` (integer) Weight.
+ `parcel_width` (integer) Parcel width.
+ `parcel_length` (integer) Parcel length.
+ `parcel_height` (integer) Parcel height.
+ `cubic_meter` (float) Cubic meter.
+ `boxes` (integer) Boxes.
+ `cartons` (integer) Cartons.
+ `pieces` (integer) Pieces.
+ `envelopes` (integer) Envelopes.
+ `pallets` (integer) Pallets.
+ `bins` (integer) Bins.
+ `trays` (integer) Trays.
+ `bundles` (integer) Bundles.
+ `rolls` (integer) Rolls.
+ `number_of_shipping_labels` (integer) Labels.
+ `attachment_url` (string) Attachment 1.
+ `carrier` (string) Carrier.
+ `auto_reschedule` (string) Reschedule.
+ `eta_time` (time) Eta time.
+ `depot` (string) Depot.
+ `depot_contact` (string) Depot contact.
+ `department` (string) Department.
+ `sales_person` (string) Sales person.
+ `identification_number` (string) Identification number.
+ `bank_prefix` (string) Bank prefix.
+ `run_number` (string) Run number.
+ `pick_up_from` (string) Pick up from.
+ `pick_up_time` (string) Pick up time.
+ `pick_up_lat` (string) Pick up lat.
+ `pick_up_lng` (string) Pick up lng.
+ `pick_up_address` (string) Pick up address.
+ `pick_up_address_1` (string) Pick up address 1.
+ `pick_up_address_2` (string) Pick up address 2.
+ `pick_up_address_3` (string) Pick up address 3.
+ `pick_up_city` (string) Pick up city.
+ `pick_up_state` (string) Pick up state.
+ `pick_up_country` (string) Pick up country.
+ `pick_up_postal_code` (string) Pick up postal code.
+ `pick_up_zone` (string) Pick up zone.
+ `job_price` (float) Job price.
+ `insurance_price` (float) Insurance price.
+ `insurance_coverage` (string) Insured.
+ `total_price` (float) Total price.
+ `payer_type` (string) Payer type.
+ `remarks` (string) Remarks.
+ `service_type` (string) Service type.
+ `warehouse_address` (string) Warehouse address.
+ `destination_time_window` (string) Destination timeslot.
+ `door` (string) Door.
+ `time_zone` (string) Time zone.
+ `vehicle_type` (string) Vehicle type.
+ `items` (array[Item]) Array of items.
+ `pod_time` (time) POD time for manual update in format HH:MM (13:30).
+ `milestones` (array[Milestone]) Array of milestones.
+ `time_window_from` (string) Completion time window start.
+ `time_window_to` (string) Completion time window end.

Readonly Attributes

+ `id` (string) Job Id.
+ `job_age` (string) Job age.
+ `detrack_number` (string) Detrack number.
+ `tracking_status` (string) Tracking status.
+ `shipper_name` (string) Shipper name.
+ `reason` (string) Reason.
+ `last_reason` (string) Last reason.
+ `received_by_sent_by` (string) Received by.
+ `note` (string) Note.
+ `live_eta` (string) Live eta.
+ `pod_lat` (string) Pod lat.
+ `pod_lng` (string) Pod lng.
+ `pod_address` (string) Pod address.
+ `info_received_at` (time) Info received at.
+ `head_to_pick_up_at` (time) Head to pick up at.
+ `pick_up_at` (time) Pick up at.
+ `scheduled_at` (time) Scheduled at.
+ `at_warehouse_at` (time) At warehouse at.
+ `out_for_delivery_at` (time) Out for delivery at.
+ `head_to_delivery_at` (time) Head to delivery at.
+ `cancelled_at` (time) Cancelled at.
+ `pick_up_failed_count` (time) Pick up failed count.
+ `deliver_failed_count` (time) Deliver failed count.
+ `pick_up_assign_to` (string) Pick up assign to.
+ `pick_up_reason` (string) Pick up reason.
+ `pod_at` (time) Pod at.
+ `texted_at` (time) Texted at.
+ `called_at` (time) Called at.
+ `address_tracked_at` (time) Address tracked at.
+ `arrived_lat` (float) Arrived lat.
+ `arrived_lng` (float) Arrived lng.
+ `arrived_address` (string) Arrived address.
+ `arrived_at` (time) Arrived at.
+ `serial_number` (string) Serial number.
+ `signed_at` (time) Signed at.
+ `photo_1_at` (time) Photo 1 at.
+ `photo_2_at` (time) Photo 2 at.
+ `photo_3_at` (time) Photo 3 at.
+ `photo_4_at` (time) Photo 4 at.
+ `photo_5_at` (time) Photo 5 at.
+ `photo_6_at` (time) Photo 6 at.
+ `photo_7_at` (time) Photo 7 at.
+ `photo_8_at` (time) Photo 8 at.
+ `photo_9_at` (time) Photo 9 at.
+ `photo_10_at` (time) Photo 10 at.
+ `signature_file_url` (string) Signature file URL.
+ `photo_1_file_url` (string) Photo 1 file URL.
+ `photo_2_file_url` (string) Photo 2 file URL.
+ `photo_3_file_url` (string) Photo 3 file URL.
+ `photo_4_file_url` (string) Photo 4 file URL.
+ `photo_5_file_url` (string) Photo 5 file URL.
+ `photo_6_file_url` (string) Photo 6 file URL.
+ `photo_7_file_url` (string) Photo 7 file URL.
+ `photo_8_file_url` (string) Photo 8 file URL.
+ `photo_9_file_url` (string) Photo 9 file URL.
+ `photo_10_file_url` (string) Photo 10 file URL.
+ `actual_weight` (integer) Actual weight.
+ `temperature` (integer) Temperature.
+ `hold_time` (integer) Hold time.
+ `payment_collected` (float) Payment collected.
+ `actual_crates` (integer) Actual crates.
+ `actual_pallets` (integer) Actual pallets.
+ `actual_utilization` (integer) Actual utilization.
+ `attempt` (integer) Attempt.
+ `goods_service_rating` (integer) Goods service rating.
+ `driver_rating` (integer) Driver rating.
+ `customer_feedback` (string) Feedback remarks.
+ `items_count` (integer) Items count.
+ `tracking_link` (string) Link to tracking wiget.

## Job Item (object)

+ `sku` (string) SKU. Required if description is blank.
+ `description` (string) Description. Required if SKU is blank.
+ `purchase_order_number` (string) Purchase order number.
+ `batch_number` (string) Batch number.
+ `expiry_date` (string) Expiry.
+ `comments` (string) Comments.
+ `quantity` (integer) Quantity.
+ `unit_of_measure` (string) Unit of measure.
+ `checked` (boolean) Checked.
+ `actual_quantity` (integer) Actual quantity.
+ `inbound_quantity` (integer) Inbound quantity.
+ `unload_time_estimate` (string) Unload time estimate.
+ `unload_time_actual` (string) Unload time actual.
+ `follow_up_quantity` (integer) Follow up quantity.
+ `follow_up_reason` (string) Follow up reason.
+ `rework_quantity` (integer) Rework quantity.
+ `rework_reason` (string) Rework reason.
+ `weight` (float) Weight.

Readonly Attribute

+ `id` (string) Job item id.
+ `photo_url` (string) Photo URL.
+ `serial_numbers` (array[string]) Serial numbers.

## Milestone (object)

+ `status` (string) Status. Job status.
+ `assign_to` (string) Driver.
+ `reason` (string) Reason for failed job.
+ `pod_at` (time) Time of status change.
+ `created_at` (time) Time of milestone created.
+ `user_name` (string) Name of user.

## List / Create [/dn/jobs{?page}{?limit}{?sort}{?type}{?date}{?assign_to}{?status}{?do_number}{?query}]

### List [GET]

+ Parameters

    + `page`: `2` (number, optional) - Page number.
        + default: `1`

    + `limit`: `50` (number, optional) - Number of records per page. Maximum 100.
        + default: `20`

    + `sort`: `-created_at` (string, optional) - Attribute to be sorted. Add minus `-` for descending order.

    + `date`: `2018-06-08` (date, optional) - Filter jobs by date (YYYY-MM-DD).

    + `type`: `Delivery` (string, optional) - Filter jobs by type (`Delivery` / `Collection`).

    + `assign_to`: `Driver A` (string) - Filter jobs by assign_to.

    + `status`: `completed,completed_partial,failed` (string) - Filter jobs by status. Use comma to seperate multiple statuses.

    + `do_number`: `DO12345` (string) - Filter jobs by DO number.

    + `query`: `DO12345` (string) - Query to search jobs for DO number, address, delivery to, notify email, assign to, tracking number and zone.

+ Request (application/json)

    + Headers

            X-API-KEY: {API_KEY}

+ Response 200 (application/json)

    + Body

            {
                "data": [
                    {
                        "id": "5b22055510c92b1a046ece04",
                        "type": "Delivery",
                        "primary_job_status": "dispatched",
                        "open_to_marketplace": false,
                        "marketplace_offer": null,
                        "do_number": "DO 0",
                        "attempt": 1,
                        "date": "2018-06-14",
                        "start_date": "2018-06-14",
                        "time_window_from": null,
                        "time_window_to": null,
                        "job_age": 1,
                        "job_release_time": null,
                        "job_time": null,
                        "time_window": null,
                        "job_received_date": null,
                        "tracking_number": "T0",
                        "order_number": "ORN12345678",
                        "job_type": null,
                        "job_sequence": null,
                        "job_fee": null,
                        "address_lat": null,
                        "address_lng": null,
                        "address": "Singapore 470140",
                        "company_name": null,
                        "address_1": null,
                        "address_2": null,
                        "address_3": null,
                        "postal_code": "470140",
                        "city": null,
                        "state": null,
                        "country": null,
                        "geocoded_lat": 1.33668219002454,
                        "geocoded_lng": 103.910711702473,
                        "billing_address": null,
                        "deliver_to_collect_from": "James Li",
                        "last_name": null,
                        "phone_number": "65432178",
                        "sender_phone_number": null,
                        "fax_number": "65432179",
                        "instructions": null,
                        "assign_to": null,
                        "notify_email": "test@example.com",
                        "webhook_url": null,
                        "zone": null,
                        "customer": null,
                        "account_number": null,
                        "job_owner": null,
                        "invoice_number": null,
                        "invoice_amount": null,
                        "payment_mode": null,
                        "payment_amount": null,
                        "group_name": null,
                        "vendor_name": null,
                        "shipper_name": null,
                        "source": null,
                        "weight": null,
                        "parcel_width": null,
                        "parcel_length": null,
                        "parcel_height": null,
                        "cubic_meter": null,
                        "boxes": null,
                        "cartons": null,
                        "pieces": null,
                        "envelopes": null,
                        "pallets": null,
                        "bins": null,
                        "trays": null,
                        "bundles": null,
                        "rolls": null,
                        "number_of_shipping_labels": null,
                        "attachment_url": null,
                        "detrack_number": "DET2000001",
                        "status": "dispatched",
                        "tracking_status": "Info received",
                        "reason": null,
                        "last_reason": null,
                        "received_by_sent_by": null,
                        "note": null,
                        "carrier": null,
                        "pod_lat": "",
                        "pod_lng": "",
                        "pod_address": "",
                        "address_tracked_at": null,
                        "arrived_lat": null,
                        "arrived_lng": null,
                        "arrived_address": null,
                        "arrived_at": null,
                        "texted_at": null,
                        "called_at": null,
                        "serial_number": null,
                        "signed_at": null,
                        "photo_1_at": null,
                        "photo_2_at": null,
                        "photo_3_at": null,
                        "photo_4_at": null,
                        "photo_5_at": null,
                        "signature_file_url": null,
                        "photo_1_file_url": null,
                        "photo_2_file_url": null,
                        "photo_3_file_url": null,
                        "photo_4_file_url": null,
                        "photo_5_file_url": null,
                        "actual_weight": null,
                        "temperature": null,
                        "hold_time": null,
                        "payment_collected": null,
                        "auto_reschedule": null,
                        "actual_crates": null,
                        "actual_pallets": null,
                        "actual_utilization": null,
                        "goods_service_rating": null,
                        "driver_rating": null,
                        "customer_feedback": null,
                        "eta_time": null,
                        "live_eta": null,
                        "depot": null,
                        "depot_contact": null,
                        "department": null,
                        "sales_person": null,
                        "identification_number": null,
                        "bank_prefix": null,
                        "run_number": null,
                        "pick_up_from": null,
                        "pick_up_time": null,
                        "pick_up_lat": null,
                        "pick_up_lng": null,
                        "pick_up_address": null,
                        "pick_up_address_1": null,
                        "pick_up_address_2": null,
                        "pick_up_address_3": null,
                        "pick_up_city": null,
                        "pick_up_state": null,
                        "pick_up_country": null,
                        "pick_up_postal_code": null,
                        "pick_up_zone": null,
                        "pick_up_assign_to": null,
                        "pick_up_reason": null,
                        "info_received_at": "2018-06-14T06:04:06.017Z",
                        "pick_up_at": null,
                        "scheduled_at": null,
                        "at_warehouse_at": null,
                        "out_for_delivery_at": null,
                        "head_to_pick_up_at": null,
                        "head_to_delivery_at": null,
                        "cancelled_at": null,
                        "pod_at": null,
                        "pick_up_failed_count": null,
                        "deliver_failed_count": null,
                        "job_price": null,
                        "insurance_price": null,
                        "insurance_coverage": false,
                        "total_price": null,
                        "payer_type": null,
                        "remarks": null,
                        "items_count": 2,
                        "service_type": null,
                        "warehouse_address": null,
                        "destination_time_window": null,
                        "door": null,
                        "time_zone": null,
                        "vehicle_type": null,
                        "created_at": "2018-06-14T06:04:06.017Z",
                        "items": [{
                            "id": "5b22055510c92b1a046ece05",
                            "sku": "12345678",
                            "purchase_order_number": null,
                            "batch_number": null,
                            "expiry_date": null,
                            "description": null,
                            "comments": null,
                            "quantity": 10,
                            "unit_of_measure": null,
                            "checked": false,
                            "actual_quantity": null,
                            "inbound_quantity": null,
                            "unload_time_estimate": null,
                            "unload_time_actual": null,
                            "follow_up_quantity": null,
                            "follow_up_reason": null,
                            "rework_quantity": null,
                            "rework_reason": null,
                            "reject_quantity": 0,
                            "reject_reason": null,
                            "weight": null,
                            "serial_numbers": [],
                            "photo_url": null
                        }, {
                            "id": "5b22055510c92b1a046ece06",
                            "sku": "12387654",
                            "purchase_order_number": null,
                            "batch_number": null,
                            "expiry_date": null,
                            "description": null,
                            "comments": null,
                            "quantity": 5,
                            "unit_of_measure": null,
                            "checked": false,
                            "actual_quantity": null,
                            "inbound_quantity": null,
                            "unload_time_estimate": null,
                            "unload_time_actual": null,
                            "follow_up_quantity": null,
                            "follow_up_reason": null,
                            "rework_quantity": null,
                            "rework_reason": null,
                            "reject_quantity": 0,
                            "reject_reason": null,
                            "weight": null,
                            "serial_numbers": [],
                            "photo_url": null
                        }],
                        "milestones": [{
                            "status": "info_recv",
                            "assign_to": null,
                            "reason": null,
                            "pod_at": "2018-06-14T06:04:06.017Z",
                            "created_at": "2018-06-14T06:04:06.017Z",
                            "user_name": "Simon"
                        }]
                    }
                ],
                "links": {
                    "next": "https://app.detrack.com/api/v2/dn/jobs?page=2&limit=10",
                    "prev": null
                }
            }

### Create [POST]

+ Request (application/json)

    + Headers

            X-API-KEY: {API_KEY}

    + Body

            {
                "data": {
                    "type": "Delivery",
                    "primary_job_status": "dispatched",
                    "open_to_marketplace": false,
                    "marketplace_offer": null,
                    "do_number": "DO 0",
                    "attempt": 1,
                    "date": "2018-06-14",
                    "start_date": "2018-06-14",
                    "time_window_from": null,
                    "time_window_to": null,
                    "job_age": 1,
                    "job_release_time": null,
                    "job_time": null,
                    "time_window": null,
                    "job_received_date": null,
                    "tracking_number": "T0",
                    "order_number": "ORN12345678",
                    "job_type": null,
                    "job_sequence": null,
                    "job_fee": null,
                    "address_lat": null,
                    "address_lng": null,
                    "address": "Singapore 470140",
                    "company_name": null,
                    "address_1": null,
                    "address_2": null,
                    "address_3": null,
                    "postal_code": "470140",
                    "city": null,
                    "state": null,
                    "country": null,
                    "geocoded_lat": 1.33668219002454,
                    "geocoded_lng": 103.910711702473,
                    "billing_address": null,
                    "deliver_to_collect_from": "James Li",
                    "last_name": null,
                    "phone_number": "65432178",
                    "sender_phone_number": null,
                    "fax_number": "65432179",
                    "instructions": null,
                    "assign_to": null,
                    "notify_email": "test@example.com",
                    "webhook_url": null,
                    "zone": null,
                    "customer": null,
                    "account_number": null,
                    "job_owner": null,
                    "invoice_number": null,
                    "invoice_amount": null,
                    "payment_mode": null,
                    "payment_amount": null,
                    "group_name": null,
                    "vendor_name": null,
                    "shipper_name": null,
                    "source": null,
                    "weight": null,
                    "parcel_width": null,
                    "parcel_length": null,
                    "parcel_height": null,
                    "cubic_meter": null,
                    "boxes": null,
                    "cartons": null,
                    "pieces": null,
                    "envelopes": null,
                    "pallets": null,
                    "bins": null,
                    "trays": null,
                    "bundles": null,
                    "rolls": null,
                    "number_of_shipping_labels": null,
                    "attachment_url": null,
                    "detrack_number": "DET2000001",
                    "status": "dispatched",
                    "tracking_status": "Info received",
                    "reason": null,
                    "last_reason": null,
                    "received_by_sent_by": null,
                    "note": null,
                    "carrier": null,
                    "pod_lat": "",
                    "pod_lng": "",
                    "pod_address": "",
                    "address_tracked_at": null,
                    "arrived_lat": null,
                    "arrived_lng": null,
                    "arrived_address": null,
                    "arrived_at": null,
                    "texted_at": null,
                    "called_at": null,
                    "serial_number": null,
                    "signed_at": null,
                    "photo_1_at": null,
                    "photo_2_at": null,
                    "photo_3_at": null,
                    "photo_4_at": null,
                    "photo_5_at": null,
                    "signature_file_url": null,
                    "photo_1_file_url": null,
                    "photo_2_file_url": null,
                    "photo_3_file_url": null,
                    "photo_4_file_url": null,
                    "photo_5_file_url": null,
                    "actual_weight": null,
                    "temperature": null,
                    "hold_time": null,
                    "payment_collected": null,
                    "auto_reschedule": null,
                    "actual_crates": null,
                    "actual_pallets": null,
                    "actual_utilization": null,
                    "goods_service_rating": null,
                    "driver_rating": null,
                    "customer_feedback": null,
                    "eta_time": null,
                    "live_eta": null,
                    "depot": null,
                    "depot_contact": null,
                    "department": null,
                    "sales_person": null,
                    "identification_number": null,
                    "bank_prefix": null,
                    "run_number": null,
                    "pick_up_from": null,
                    "pick_up_time": null,
                    "pick_up_lat": null,
                    "pick_up_lng": null,
                    "pick_up_address": null,
                    "pick_up_address_1": null,
                    "pick_up_address_2": null,
                    "pick_up_address_3": null,
                    "pick_up_city": null,
                    "pick_up_state": null,
                    "pick_up_country": null,
                    "pick_up_postal_code": null,
                    "pick_up_zone": null,
                    "pick_up_assign_to": null,
                    "pick_up_reason": null,
                    "info_received_at": "2018-06-14T06:04:06.017Z",
                    "pick_up_at": null,
                    "scheduled_at": null,
                    "at_warehouse_at": null,
                    "out_for_delivery_at": null,
                    "head_to_pick_up_at": null,
                    "head_to_delivery_at": null,
                    "cancelled_at": null,
                    "pod_at": null,
                    "pick_up_failed_count": null,
                    "deliver_failed_count": null,
                    "job_price": null,
                    "insurance_price": null,
                    "insurance_coverage": false,
                    "total_price": null,
                    "payer_type": null,
                    "remarks": null,
                    "items_count": 2,
                    "service_type": null,
                    "warehouse_address": null,
                    "destination_time_window": null,
                    "door": null,
                    "time_zone": null,
                    "vehicle_type": null,
                    "created_at": "2018-06-14T06:04:06.017Z",
                    "items": [{
                        "id": "5b22055510c92b1a046ece05",
                        "sku": "12345678",
                        "purchase_order_number": null,
                        "batch_number": null,
                        "expiry_date": null,
                        "description": null,
                        "comments": null,
                        "quantity": 10,
                        "unit_of_measure": null,
                        "checked": false,
                        "actual_quantity": null,
                        "inbound_quantity": null,
                        "unload_time_estimate": null,
                        "unload_time_actual": null,
                        "follow_up_quantity": null,
                        "follow_up_reason": null,
                        "rework_quantity": null,
                        "rework_reason": null,
                        "reject_quantity": 0,
                        "reject_reason": null,
                        "weight": null,
                        "serial_numbers": [],
                        "photo_url": null
                    }, {
                        "id": "5b22055510c92b1a046ece06",
                        "sku": "12387654",
                        "purchase_order_number": null,
                        "batch_number": null,
                        "expiry_date": null,
                        "description": null,
                        "comments": null,
                        "quantity": 5,
                        "unit_of_measure": null,
                        "checked": false,
                        "actual_quantity": null,
                        "inbound_quantity": null,
                        "unload_time_estimate": null,
                        "unload_time_actual": null,
                        "follow_up_quantity": null,
                        "follow_up_reason": null,
                        "rework_quantity": null,
                        "rework_reason": null,
                        "reject_quantity": 0,
                        "reject_reason": null,
                        "weight": null,
                        "serial_numbers": [],
                        "photo_url": null
                    }]
                }
            }

+ Response 201 (application/json)

    + Headers

            Location: https://app.detrack.com/api/v2/dn/jobs/{do_number}

    + Body

            {
                "data": {
                    "id": "5b22055510c92b1a046ece04",
                    "type": "Delivery",
                    "primary_job_status": "dispatched",
                    "open_to_marketplace": false,
                    "marketplace_offer": null,
                    "do_number": "DO 0",
                    "attempt": 1,
                    "date": "2018-06-14",
                    "start_date": "2018-06-14",
                    "time_window_from": null,
                    "time_window_to": null,
                    "job_age": 1,
                    "job_release_time": null,
                    "job_time": null,
                    "time_window": null,
                    "job_received_date": null,
                    "tracking_number": "T0",
                    "order_number": "ORN12345678",
                    "job_type": null,
                    "job_sequence": null,
                    "job_fee": null,
                    "address_lat": null,
                    "address_lng": null,
                    "address": "Singapore 470140",
                    "company_name": null,
                    "address_1": null,
                    "address_2": null,
                    "address_3": null,
                    "postal_code": "470140",
                    "city": null,
                    "state": null,
                    "country": null,
                    "geocoded_lat": 1.33668219002454,
                    "geocoded_lng": 103.910711702473,
                    "billing_address": null,
                    "deliver_to_collect_from": "James Li",
                    "last_name": null,
                    "phone_number": "65432178",
                    "sender_phone_number": null,
                    "fax_number": "65432179",
                    "instructions": null,
                    "assign_to": null,
                    "notify_email": "test@example.com",
                    "webhook_url": null,
                    "zone": null,
                    "customer": null,
                    "account_number": null,
                    "job_owner": null,
                    "invoice_number": null,
                    "invoice_amount": null,
                    "payment_mode": null,
                    "payment_amount": null,
                    "group_name": null,
                    "vendor_name": null,
                    "shipper_name": null,
                    "source": null,
                    "weight": null,
                    "parcel_width": null,
                    "parcel_length": null,
                    "parcel_height": null,
                    "cubic_meter": null,
                    "boxes": null,
                    "cartons": null,
                    "pieces": null,
                    "envelopes": null,
                    "pallets": null,
                    "bins": null,
                    "trays": null,
                    "bundles": null,
                    "rolls": null,
                    "number_of_shipping_labels": null,
                    "attachment_url": null,
                    "detrack_number": "DET2000001",
                    "status": "dispatched",
                    "tracking_status": "Info received",
                    "reason": null,
                    "last_reason": null,
                    "received_by_sent_by": null,
                    "note": null,
                    "carrier": null,
                    "pod_lat": "",
                    "pod_lng": "",
                    "pod_address": "",
                    "address_tracked_at": null,
                    "arrived_lat": null,
                    "arrived_lng": null,
                    "arrived_address": null,
                    "arrived_at": null,
                    "texted_at": null,
                    "called_at": null,
                    "serial_number": null,
                    "signed_at": null,
                    "photo_1_at": null,
                    "photo_2_at": null,
                    "photo_3_at": null,
                    "photo_4_at": null,
                    "photo_5_at": null,
                    "signature_file_url": null,
                    "photo_1_file_url": null,
                    "photo_2_file_url": null,
                    "photo_3_file_url": null,
                    "photo_4_file_url": null,
                    "photo_5_file_url": null,
                    "actual_weight": null,
                    "temperature": null,
                    "hold_time": null,
                    "payment_collected": null,
                    "auto_reschedule": null,
                    "actual_crates": null,
                    "actual_pallets": null,
                    "actual_utilization": null,
                    "goods_service_rating": null,
                    "driver_rating": null,
                    "customer_feedback": null,
                    "eta_time": null,
                    "live_eta": null,
                    "depot": null,
                    "depot_contact": null,
                    "department": null,
                    "sales_person": null,
                    "identification_number": null,
                    "bank_prefix": null,
                    "run_number": null,
                    "pick_up_from": null,
                    "pick_up_time": null,
                    "pick_up_lat": null,
                    "pick_up_lng": null,
                    "pick_up_address": null,
                    "pick_up_address_1": null,
                    "pick_up_address_2": null,
                    "pick_up_address_3": null,
                    "pick_up_city": null,
                    "pick_up_state": null,
                    "pick_up_country": null,
                    "pick_up_postal_code": null,
                    "pick_up_zone": null,
                    "pick_up_assign_to": null,
                    "pick_up_reason": null,
                    "info_received_at": "2018-06-14T06:04:06.017Z",
                    "pick_up_at": null,
                    "scheduled_at": null,
                    "at_warehouse_at": null,
                    "out_for_delivery_at": null,
                    "head_to_pick_up_at": null,
                    "head_to_delivery_at": null,
                    "cancelled_at": null,
                    "pod_at": null,
                    "pick_up_failed_count": null,
                    "deliver_failed_count": null,
                    "job_price": null,
                    "insurance_price": null,
                    "insurance_coverage": false,
                    "total_price": null,
                    "payer_type": null,
                    "remarks": null,
                    "items_count": 2,
                    "service_type": null,
                    "warehouse_address": null,
                    "destination_time_window": null,
                    "door": null,
                    "time_zone": null,
                    "vehicle_type": null,
                    "created_at": "2018-06-14T06:04:06.017Z",
                    "items": [{
                        "id": "5b22055510c92b1a046ece05",
                        "sku": "12345678",
                        "purchase_order_number": null,
                        "batch_number": null,
                        "expiry_date": null,
                        "description": null,
                        "comments": null,
                        "quantity": 10,
                        "unit_of_measure": null,
                        "checked": false,
                        "actual_quantity": null,
                        "inbound_quantity": null,
                        "unload_time_estimate": null,
                        "unload_time_actual": null,
                        "follow_up_quantity": null,
                        "follow_up_reason": null,
                        "rework_quantity": null,
                        "rework_reason": null,
                        "reject_quantity": 0,
                        "reject_reason": null,
                        "weight": null,
                        "serial_numbers": [],
                        "photo_url": null
                    }, {
                        "id": "5b22055510c92b1a046ece06",
                        "sku": "12387654",
                        "purchase_order_number": null,
                        "batch_number": null,
                        "expiry_date": null,
                        "description": null,
                        "comments": null,
                        "quantity": 5,
                        "unit_of_measure": null,
                        "checked": false,
                        "actual_quantity": null,
                        "inbound_quantity": null,
                        "unload_time_estimate": null,
                        "unload_time_actual": null,
                        "follow_up_quantity": null,
                        "follow_up_reason": null,
                        "rework_quantity": null,
                        "rework_reason": null,
                        "reject_quantity": 0,
                        "reject_reason": null,
                        "weight": null,
                        "serial_numbers": [],
                        "photo_url": null
                    }],
                    "milestones": [{
                        "status": "info_recv",
                        "assign_to": null,
                        "reason": null,
                        "pod_at": "2018-06-14T06:04:06.017Z",
                        "created_at": "2018-06-14T06:04:06.017Z",
                        "user_name": "Simon"
                    }]

                }
            }

## Batch Create [/dn/jobs/bulk]

Create up to 100 jobs per request.

### Create [POST]

+ Request (application/json)

    + Headers

            X-API-KEY: {API_KEY}

    + Body

            {
                "data": [
                  {
                    "type": "Delivery",
                    "do_number": "DO 0",
                    "date": "2018-06-14",
                    "tracking_number": "T0",
                    "order_number": "ORN12345678",
                    "address": "Singapore 470140",
                    "deliver_to_collect_from": "James Li",
                    "phone_number": "65432178",
                    "fax_number": "65432179",
                    "notify_email": "test@email.com",
                    "items": [{
                        "sku": "12345678",
                        "description": "iPad",
                        "quantity": 10
                    }, {
                        "sku": "12345688",
                        "description": "iPhone",
                        "quantity": 10
                    }]
                  },
                  {
                    "type": "Delivery",
                    "do_number": "DO 1",
                    "date": "2018-06-14",
                    "tracking_number": "T0",
                    "order_number": "ORN12345688",
                    "address": "Singapore 470150",
                    "deliver_to_collect_from": "Simon Loh",
                    "phone_number": "65432178",
                    "fax_number": "65432179",
                    "notify_email": "simon@test.com",
                    "items": [{
                        "sku": "12345678",
                        "description": "iPad",
                        "quantity": 10
                    }, {
                        "sku": "12345688",
                        "description": "iPhone",
                        "quantity": 10
                    }]
                  }
                ]
            }

+ Response 200 (application/json)

    + Body

            {
                "data": [
                  {
                    "id": "5b28c8e810c92b1fe0f9571a",
                    "type": "Delivery",
                    "do_number": "DO 0",
                    "date": "2018-06-14",
                    "tracking_number": "T0",
                    "order_number": "ORN12345678",
                    "address": "Singapore 470140",
                    "deliver_to_collect_from": "James Li",
                    "phone_number": "65432178",
                    "fax_number": "65432179",
                    "notify_email": "test@email.com",
                    "items": [{
                        "id": "5b28c8e810c92b1fe0f9571e",
                        "sku": "12345678",
                        "description": "iPad",
                        "quantity": 10
                    }, {
                        "id": "5b28c8e810c92b1fe0f9571f",
                        "sku": "12345688",
                        "description": "iPhone",
                        "quantity": 10
                    }]
                  },
                  {
                    "id": "5b28c8e810c92b1fe0f9571b",
                    "type": "Delivery",
                    "do_number": "DO 1",
                    "date": "2018-06-14",
                    "tracking_number": "T0",
                    "order_number": "ORN12345688",
                    "address": "Singapore 470150",
                    "deliver_to_collect_from": "Simon Loh",
                    "phone_number": "65432178",
                    "fax_number": "65432179",
                    "notify_email": "simon@test.com",
                    "items": [{
                        "id": "5b28c8e810c92b1fe0f9571c",
                        "sku": "12345678",
                        "description": "iPad",
                        "quantity": 10
                    }, {
                        "id": "5b28c8e810c92b1fe0f9571d",
                        "sku": "12345688",
                        "description": "iPhone",
                        "quantity": 10
                    }]
                  }
                ]
            }

+ Response 422 (application/json)

    + Body

            {
                "code": "validation_failed",
                "message": "Validation failed",
                "data": [
                  {
                    "id": "5b28c8e810c92b1fe0f9571a",
                    "type": "Delivery",
                    "do_number": "DO 0",
                    "date": "2018-06-14",
                    "tracking_number": "T0",
                    "order_number": "ORN12345678",
                    "address": "Singapore 470140",
                    "deliver_to_collect_from": "James Li",
                    "phone_number": "65432178",
                    "fax_number": "65432179",
                    "notify_email": "test@email.com",
                    "items": [{
                        "id": "5b28c8e810c92b1fe0f9571e",
                        "sku": "12345678",
                        "description": "iPad",
                        "quantity": 10
                    }, {
                        "id": "5b28c8e810c92b1fe0f9571f",
                        "sku": "12345688",
                        "description": "iPhone",
                        "quantity": 10
                    }]
                  }
                ],
                errors: [
                  {
                    "id": "5b28c8e810c92b1fe0f9571b",
                    "type": "Delivery",
                    "do_number": "",
                    "date": "2018-06-14",
                    "tracking_number": "T0",
                    "order_number": "ORN12345688",
                    "address": "Singapore 470150",
                    "deliver_to_collect_from": "Simon Loh",
                    "phone_number": "65432178",
                    "fax_number": "65432179",
                    "notify_email": "simon@test.com",
                    "items": [{
                        "id": "5b28c8e810c92b1fe0f9571c",
                        "sku": "12345678",
                        "description": "iPad",
                        "quantity": 10
                    }, {
                        "id": "5b28c8e810c92b1fe0f9571d",
                        "sku": "12345688",
                        "description": "iPhone",
                        "quantity": 10
                    }],
                    errors: [
                      { field: 'do_number', codes: ['cannot be blank']}
                    ]
                  }
                ]
            }


## Batch Update / Delete [/dn/jobs]

Update / Delete up to 100 jobs per request.

## Update (object)

+ `do_number` (string required) - D.O No.
+ `date` (date, optional) - Date.
+ `type` (string, optional) - Detrack Job Type. Must be `Delivery` / `Collection`.
+ `data` (object) - Job object with fields and values to be updated.
+ `overwrite` (boolean, optional) - Set to `true` if you would like to overwrite completed jobs.

## Delete (object)

+ `do_number` (string required) D.O No.
+ `date` (date, optional) Date.
+ `type` (string, optional) Detrack Job Type. Must be `Delivery` or `Collection`.

### Update [PUT]

+ Request (application/json)

    + Headers

            X-API-KEY: {API_KEY}

    + Body

            {
                "data": [
                    {
                        "do_number": "5b22055510c92b1a046ece05",
                        "type": "Delivery",
                        "overwrite": true,
                        "data": { "job_sequence": 1 }
                    },
                    {
                        "do_number": "5b22055510c92b1a046ece06",
                        "date": "2020-08-20",
                        "type": "Delivery",
                        "data": { "job_sequence": 2 }
                    },
                    {
                        "do_number": "5b22055510c92b1a046ece07",
                        "type": "Delivery",
                        "data": { "job_sequence": 3 }
                    }
                ]
            }

+ Response 200 (application/json)

    + Body

            {
                "data": [
                    {
                        "do_number": "5b22055510c92b1a046ece05",
                        "date": null,
                        "type": "Delivery",
                        "ok": true
                    },
                    {
                        "do_number": "5b22055510c92b1a046ece06",
                        "date": "2020-08-20",
                        "type": "Delivery",
                        "ok": true
                    },
                    {
                        "do_number": "5b22055510c92b1a046ece07",
                        "date": null,
                        "type": "Delivery",
                        "ok": true
                    }
                ]
            }

+ Response 422 (application/json)

    + Body

            {
                "data": {
                    "data": [
                        {
                            "do_number": "5b22055510c92b1a046ece05",
                            "date": null,
                            "type": "Delivery",
                            "ok": true
                        },
                        {
                            "do_number": "5b22055510c92b1a046ece06",
                            "date": null,
                            "type": "Delivery",
                            "ok": true
                        },
                        {
                            "do_number": "5b22055510c92b1a046ece07",
                            "date": null,
                            "type": "Delivery",
                            "ok": false
                        }
                    ]
                },
                "code": "validation_failed",
                "message": "Validation failed",
                "errors": [{
                    "do_number": "5b22055510c92b1a046ece07",
                    "date": null,
                    "type": "Delivery",
                    "field": "job_sequence",
                    "codes": ["not_a_number"]
                }]

            }


### Delete [DELETE]

+ Request (application/json)

    + Headers

            X-API-KEY: {API_KEY}

    + Body

            {
                "data": [
                    {
                        "do_number": "5b22055510c92b1a046ece05",
                        "date": "2019-03-08",
                        "type": "Delivery"
                    },
                    {
                        "do_number": "5b22055510c92b1a046ece06"
                        "date": "2019-03-08",
                        "type": "Delivery"
                    },
                    {
                        "do_number": "5b22055510c92b1a046ece07"
                        "date": "2019-03-08",
                        "type": "Delivery"
                    }
                ]
            }

+ Response 200 (application/json)

    + Body

            {
                "data": [
                    {
                        "do_number": "5b22055510c92b1a046ece05",
                        "date": "2019-03-08",
                        "type": "Delivery",
                        "ok": true
                    },
                    {
                        "do_number": "5b22055510c92b1a046ece06",
                        "date": "2019-03-08",
                        "type": null,
                        "ok": true
                    },
                    {
                        "do_number": "5b22055510c92b1a046ece07",
                        "date": "2019-03-08",
                        "type": null,
                        "ok": true
                    }
                ]
            }

+ Response 422 (application/json)

    + Body

            {
                "data": [
                    {
                        "do_number": "5b22055510c92b1a046ece05",
                        "date": "2019-03-08",
                        "type": "Delivery",
                        "ok": true
                    },
                    {
                        "do_number": "5b22055510c92b1a046ece06",
                        "date": "2019-03-08",
                        "type": null,
                        "ok": true
                    },
                    {
                        "do_number": "5b22055510c92b1a046ece07",
                        "date": "2019-03-08",
                        "type": null,
                        "ok": false
                    }
                ],
                "code": "deletion_failed",
                "message": "Deletion failed",
                "errors": [{
                    "do_number": "5b22055510c92b1a046ece07",
                    "date": "2019-03-08",
                    "type": null,
                    "codes": ["undeletable"]
                }]
            }

## Batch Export [/dn/jobs/bulk/export]

This is for exporting of shipping labels or pod in batches by providing a list of DO number in the query object and an optional date.
It will response with an URL for checking the progress of the export. . Limited to 1000 jobs per request.

## Export (object)

+ `query` (object required) - Query object.
+ `document` (string, required) - Document Type. Must be `shipping-labels` / `pod`. Defaults to `pod`.

## Query (object)

+ `do_numbers` (array[String] required) - Array of D.O nos.
+ `date` (date optional) - Job date.
+ `type` (string optional) - Filter the export by type. Must be `Delivery` / `Collection`. If blank, both delivery and collection will be exported.

### Export [POST]

+ Request (application/json)

    + Headers

            X-API-KEY: {API_KEY}

    + Body

            {
                "data": {
                    "query": {
                        "do_numbers": [
                            "123456",
                            "654321"
                        ],
                        "date": "2022-02-22"
                    },
                    "document": "shipping-labels"
                }

            }

+ Response 200 (application/json)

    + Body

            {
                "data": {
                    "status_url": "https://app.detrack.com/api/v2/dn/jobs/export/status/5b22033310c92b1a086ece03"
                }
            }

## Get Export Status [/dn/jobs/export/status/{id}]

This is for checking the progress of the batch export. It will provide a download URL once exporting has completed. You may then use the download URL to download the exported file.

### Get Status [GET]

+ Parameters

    + id: `5b22033310c92b1a086ece03` (string, required) - Id of export.

+ Request (application/json)

    + Headers

            X-API-KEY: {API_KEY}

+ Response 200 (application/json)

    + Body

            {
                "data": {
                    "status": "completed",
                    "download_url": "https://detrack-exports.s3.dualstack.us-west-2.amazonaws.com/eb38494bd8a30498e76c890f/shipping-labels.pdf?response-content-disposition=attachment%3Bfilename%3Dshipping-labels.pdf&X-Amz-Algorithm=AWS4-HMAC-SHA256&X-Amz-Credential=AKIAJMOL6O2EG6TY2XCA%2F20220223%2Fus-west-2%2Fs3%2Faws4_request&X-Amz-Date=20220223T004851Z&X-Amz-Expires=900&X-Amz-SignedHeaders=host&X-Amz-Signature=5778549def8fd9c2ed45b9bf75618c69c2b856683b2a9ad3fa3bb5e3df387d96"
                }
            }

## Retrieve Job by DO [/dn/jobs/show/{?do_number}{?date}{?type}]

### Retrieve [GET]

+ Parameters

    + do_number: `12345678` (string, required) - Job DO number to be retrieved.
    + date: `2021-04-09` (string, optional) - Date of job.
    + type: `Delivery` (string, optional) - Detrack Job Type to be retrieved. Must be `Delivery` or `Collection`.

+ Request (application/json)

    + Headers

            X-API-KEY: {API_KEY}

+ Response 200 (application/json)

    + Body

            {
                "data": {
                    "id": "5b22055510c92b1a046ece04",
                    "type": "Delivery",
                    "primary_job_status": "dispatched",
                    "open_to_marketplace": false,
                    "marketplace_offer": null,
                    "do_number": "DO 0",
                    "attempt": 1,
                    "date": "2018-06-14",
                    "start_date": "2018-06-14",
                    "time_window_from": null,
                    "time_window_to": null,
                    "job_age": 1,
                    "job_release_time": null,
                    "job_time": null,
                    "time_window": null,
                    "job_received_date": null,
                    "tracking_number": "T0",
                    "order_number": "ORN12345678",
                    "job_type": null,
                    "job_sequence": null,
                    "job_fee": null,
                    "address_lat": null,
                    "address_lng": null,
                    "address": "Singapore 470140",
                    "company_name": null,
                    "address_1": null,
                    "address_2": null,
                    "address_3": null,
                    "postal_code": "470140",
                    "city": null,
                    "state": null,
                    "country": null,
                    "geocoded_lat": 1.33668219002454,
                    "geocoded_lng": 103.910711702473,
                    "billing_address": null,
                    "deliver_to_collect_from": "James Li",
                    "last_name": null,
                    "phone_number": "65432178",
                    "sender_phone_number": null,
                    "fax_number": "65432179",
                    "instructions": null,
                    "assign_to": null,
                    "notify_email": "test@example.com",
                    "webhook_url": null,
                    "zone": null,
                    "customer": null,
                    "account_number": null,
                    "job_owner": null,
                    "invoice_number": null,
                    "invoice_amount": null,
                    "payment_mode": null,
                    "payment_amount": null,
                    "group_name": null,
                    "vendor_name": null,
                    "shipper_name": null,
                    "source": null,
                    "weight": null,
                    "parcel_width": null,
                    "parcel_length": null,
                    "parcel_height": null,
                    "cubic_meter": null,
                    "boxes": null,
                    "cartons": null,
                    "pieces": null,
                    "envelopes": null,
                    "pallets": null,
                    "bins": null,
                    "trays": null,
                    "bundles": null,
                    "rolls": null,
                    "number_of_shipping_labels": null,
                    "attachment_url": null,
                    "detrack_number": "DET2000001",
                    "status": "dispatched",
                    "tracking_status": "Info received",
                    "reason": null,
                    "last_reason": null,
                    "received_by_sent_by": null,
                    "note": null,
                    "carrier": null,
                    "pod_lat": "",
                    "pod_lng": "",
                    "pod_address": "",
                    "address_tracked_at": null,
                    "arrived_lat": null,
                    "arrived_lng": null,
                    "arrived_address": null,
                    "arrived_at": null,
                    "texted_at": null,
                    "called_at": null,
                    "serial_number": null,
                    "signed_at": null,
                    "photo_1_at": null,
                    "photo_2_at": null,
                    "photo_3_at": null,
                    "photo_4_at": null,
                    "photo_5_at": null,
                    "signature_file_url": null,
                    "photo_1_file_url": null,
                    "photo_2_file_url": null,
                    "photo_3_file_url": null,
                    "photo_4_file_url": null,
                    "photo_5_file_url": null,
                    "actual_weight": null,
                    "temperature": null,
                    "hold_time": null,
                    "payment_collected": null,
                    "auto_reschedule": null,
                    "actual_crates": null,
                    "actual_pallets": null,
                    "actual_utilization": null,
                    "goods_service_rating": null,
                    "driver_rating": null,
                    "customer_feedback": null,
                    "eta_time": null,
                    "live_eta": null,
                    "depot": null,
                    "depot_contact": null,
                    "department": null,
                    "sales_person": null,
                    "identification_number": null,
                    "bank_prefix": null,
                    "run_number": null,
                    "pick_up_from": null,
                    "pick_up_time": null,
                    "pick_up_lat": null,
                    "pick_up_lng": null,
                    "pick_up_address": null,
                    "pick_up_address_1": null,
                    "pick_up_address_2": null,
                    "pick_up_address_3": null,
                    "pick_up_city": null,
                    "pick_up_state": null,
                    "pick_up_country": null,
                    "pick_up_postal_code": null,
                    "pick_up_zone": null,
                    "pick_up_assign_to": null,
                    "pick_up_reason": null,
                    "info_received_at": "2018-06-14T06:04:06.017Z",
                    "pick_up_at": null,
                    "scheduled_at": null,
                    "at_warehouse_at": null,
                    "out_for_delivery_at": null,
                    "head_to_pick_up_at": null,
                    "head_to_delivery_at": null,
                    "cancelled_at": null,
                    "pod_at": null,
                    "pick_up_failed_count": null,
                    "deliver_failed_count": null,
                    "job_price": null,
                    "insurance_price": null,
                    "insurance_coverage": false,
                    "total_price": null,
                    "payer_type": null,
                    "remarks": null,
                    "items_count": 2,
                    "service_type": null,
                    "warehouse_address": null,
                    "destination_time_window": null,
                    "door": null,
                    "time_zone": null,
                    "vehicle_type": null,
                    "created_at": "2018-06-14T06:04:06.017Z",
                    "items": [{
                        "id": "5b22055510c92b1a046ece05",
                        "sku": "12345678",
                        "purchase_order_number": null,
                        "batch_number": null,
                        "expiry_date": null,
                        "description": null,
                        "comments": null,
                        "quantity": 10,
                        "unit_of_measure": null,
                        "checked": false,
                        "actual_quantity": null,
                        "inbound_quantity": null,
                        "unload_time_estimate": null,
                        "unload_time_actual": null,
                        "follow_up_quantity": null,
                        "follow_up_reason": null,
                        "rework_quantity": null,
                        "rework_reason": null,
                        "reject_quantity": 0,
                        "reject_reason": null,
                        "weight": null,
                        "serial_numbers": [],
                        "photo_url": null
                    }, {
                        "id": "5b22055510c92b1a046ece06",
                        "sku": "12387654",
                        "purchase_order_number": null,
                        "batch_number": null,
                        "expiry_date": null,
                        "description": null,
                        "comments": null,
                        "quantity": 5,
                        "unit_of_measure": null,
                        "checked": false,
                        "actual_quantity": null,
                        "inbound_quantity": null,
                        "unload_time_estimate": null,
                        "unload_time_actual": null,
                        "follow_up_quantity": null,
                        "follow_up_reason": null,
                        "rework_quantity": null,
                        "rework_reason": null,
                        "reject_quantity": 0,
                        "reject_reason": null,
                        "weight": null,
                        "serial_numbers": [],
                        "photo_url": null
                    }],
                    "milestones": [{
                        "status": "info_recv",
                        "assign_to": null,
                        "reason": null,
                        "pod_at": "2018-06-14T06:04:06.017Z",
                        "created_at": "2018-06-14T06:04:06.017Z",
                        "user_name": "Simon"
                    }]
                }
            }

## Update Job by DO [/dn/jobs/update]

## Update (object)

+ `do_number` (string required) - D.O No.
+ `date` (date, optional) - Date.
+ `type` (string, optional) - Detrack Job Type. Must be `Delivery` / `Collection`.
+ `data` (object) - Job object with fields and values to be updated.

### Update [PUT]

+ Request (application/json)

    + Headers

            X-API-KEY: {API_KEY}

    + Body

            {
                "do_number": "12345678",
                "date": "2021-04-09",
                "type": "Delivery",
                "data": {
                    "type": "Delivery",
                    "primary_job_status": "dispatched",
                    "open_to_marketplace": false,
                    "marketplace_offer": null,
                    "do_number": "DO 0",
                    "attempt": 1,
                    "date": "2018-06-14",
                    "start_date": "2018-06-14",
                    "job_age": 1,
                    "job_release_time": null,
                    "job_time": null,
                    "time_window": null,
                    "job_received_date": null,
                    "tracking_number": "T0",
                    "order_number": "ORN12345678",
                    "job_type": null,
                    "job_sequence": null,
                    "job_fee": null,
                    "address_lat": null,
                    "address_lng": null,
                    "address": "Singapore 470140",
                    "company_name": null,
                    "address_1": null,
                    "address_2": null,
                    "address_3": null,
                    "postal_code": "470140",
                    "city": null,
                    "state": null,
                    "country": null,
                    "billing_address": null,
                    "deliver_to_collect_from": "James Li",
                    "last_name": null,
                    "phone_number": "65432178",
                    "sender_phone_number": null,
                    "fax_number": "65432179",
                    "instructions": null,
                    "assign_to": null,
                    "notify_email": "test@example.com",
                    "webhook_url": null,
                    "zone": null,
                    "customer": null,
                    "account_number": null,
                    "job_owner": null,
                    "invoice_number": null,
                    "invoice_amount": null,
                    "payment_mode": null,
                    "payment_amount": null,
                    "group_name": null,
                    "vendor_name": null,
                    "shipper_name": null,
                    "source": null,
                    "weight": null,
                    "parcel_width": null,
                    "parcel_length": null,
                    "parcel_height": null,
                    "cubic_meter": null,
                    "boxes": null,
                    "cartons": null,
                    "pieces": null,
                    "envelopes": null,
                    "pallets": null,
                    "bins": null,
                    "trays": null,
                    "bundles": null,
                    "rolls": null,
                    "number_of_shipping_labels": null,
                    "attachment_url": null,
                    "detrack_number": "DET2000001",
                    "status": "dispatched",
                    "tracking_status": "Info received",
                    "reason": null,
                    "last_reason": null,
                    "received_by_sent_by": null,
                    "note": null,
                    "carrier": null,
                    "pod_lat": "",
                    "pod_lng": "",
                    "pod_address": "",
                    "address_tracked_at": null,
                    "arrived_lat": null,
                    "arrived_lng": null,
                    "arrived_address": null,
                    "arrived_at": null,
                    "texted_at": null,
                    "called_at": null,
                    "serial_number": null,
                    "signed_at": null,
                    "photo_1_at": null,
                    "photo_2_at": null,
                    "photo_3_at": null,
                    "photo_4_at": null,
                    "photo_5_at": null,
                    "signature_file_url": null,
                    "photo_1_file_url": null,
                    "photo_2_file_url": null,
                    "photo_3_file_url": null,
                    "photo_4_file_url": null,
                    "photo_5_file_url": null,
                    "actual_weight": null,
                    "temperature": null,
                    "hold_time": null,
                    "payment_collected": null,
                    "auto_reschedule": null,
                    "actual_crates": null,
                    "actual_pallets": null,
                    "actual_utilization": null,
                    "goods_service_rating": null,
                    "driver_rating": null,
                    "customer_feedback": null,
                    "eta_time": null,
                    "live_eta": null,
                    "depot": null,
                    "depot_contact": null,
                    "department": null,
                    "sales_person": null,
                    "identification_number": null,
                    "bank_prefix": null,
                    "run_number": null,
                    "pick_up_from": null,
                    "pick_up_time": null,
                    "pick_up_lat": null,
                    "pick_up_lng": null,
                    "pick_up_address": null,
                    "pick_up_address_1": null,
                    "pick_up_address_2": null,
                    "pick_up_address_3": null,
                    "pick_up_city": null,
                    "pick_up_state": null,
                    "pick_up_country": null,
                    "pick_up_postal_code": null,
                    "pick_up_zone": null,
                    "pick_up_assign_to": null,
                    "pick_up_reason": null,
                    "info_received_at": "2018-06-14T06:04:06.017Z",
                    "pick_up_at": null,
                    "scheduled_at": null,
                    "at_warehouse_at": null,
                    "out_for_delivery_at": null,
                    "head_to_pick_up_at": null,
                    "head_to_delivery_at": null,
                    "cancelled_at": null,
                    "pod_at": null,
                    "pick_up_failed_count": null,
                    "deliver_failed_count": null,
                    "job_price": null,
                    "insurance_price": null,
                    "insurance_coverage": false,
                    "total_price": null,
                    "payer_type": null,
                    "remarks": null,
                    "items_count": 2,
                    "service_type": null,
                    "warehouse_address": null,
                    "destination_time_window": null,
                    "door": null,
                    "time_zone": null,
                    "vehicle_type": null,
                    "created_at": "2018-06-14T06:04:06.017Z",
                    "items": [{
                        "sku": "12345678",
                        "purchase_order_number": null,
                        "batch_number": null,
                        "expiry_date": null,
                        "description": null,
                        "comments": null,
                        "quantity": 10,
                        "unit_of_measure": null,
                        "checked": false,
                        "actual_quantity": null,
                        "inbound_quantity": null,
                        "unload_time_estimate": null,
                        "unload_time_actual": null,
                        "follow_up_quantity": null,
                        "follow_up_reason": null,
                        "rework_quantity": null,
                        "rework_reason": null,
                        "reject_quantity": 0,
                        "reject_reason": null,
                        "weight": null,
                        "serial_numbers": [],
                        "photo_url": null
                    }, {
                        "sku": "12387654",
                        "purchase_order_number": null,
                        "batch_number": null,
                        "expiry_date": null,
                        "description": null,
                        "comments": null,
                        "quantity": 5,
                        "unit_of_measure": null,
                        "checked": false,
                        "actual_quantity": null,
                        "inbound_quantity": null,
                        "unload_time_estimate": null,
                        "unload_time_actual": null,
                        "follow_up_quantity": null,
                        "follow_up_reason": null,
                        "rework_quantity": null,
                        "rework_reason": null,
                        "reject_quantity": 0,
                        "reject_reason": null,
                        "weight": null,
                        "serial_numbers": [],
                        "photo_url": null
                    }]
                }
            }

+ Response 200 (application/json)

    + Body

            {
                "data": {
                    "id": "5b22055510c92b1a046ece04",
                    "type": "Delivery",
                    "primary_job_status": "dispatched",
                    "open_to_marketplace": false,
                    "marketplace_offer": null,
                    "do_number": "DO 0",
                    "attempt": 1,
                    "date": "2018-06-14",
                    "start_date": "2018-06-14",
                    "job_age": 1,
                    "job_release_time": null,
                    "job_time": null,
                    "time_window": null,
                    "job_received_date": null,
                    "tracking_number": "T0",
                    "order_number": "ORN12345678",
                    "job_type": null,
                    "job_sequence": null,
                    "job_fee": null,
                    "address_lat": null,
                    "address_lng": null,
                    "address": "Singapore 470140",
                    "company_name": null,
                    "address_1": null,
                    "address_2": null,
                    "address_3": null,
                    "postal_code": "470140",
                    "city": null,
                    "state": null,
                    "country": null,
                    "geocoded_lat": 1.33668219002454,
                    "geocoded_lng": 103.910711702473,
                    "billing_address": null,
                    "deliver_to_collect_from": "James Li",
                    "last_name": null,
                    "phone_number": "65432178",
                    "sender_phone_number": null,
                    "fax_number": "65432179",
                    "instructions": null,
                    "assign_to": null,
                    "notify_email": "test@example.com",
                    "webhook_url": null,
                    "zone": null,
                    "customer": null,
                    "account_number": null,
                    "job_owner": null,
                    "invoice_number": null,
                    "invoice_amount": null,
                    "payment_mode": null,
                    "payment_amount": null,
                    "group_name": null,
                    "vendor_name": null,
                    "shipper_name": null,
                    "source": null,
                    "weight": null,
                    "parcel_width": null,
                    "parcel_length": null,
                    "parcel_height": null,
                    "cubic_meter": null,
                    "boxes": null,
                    "cartons": null,
                    "pieces": null,
                    "envelopes": null,
                    "pallets": null,
                    "bins": null,
                    "trays": null,
                    "bundles": null,
                    "rolls": null,
                    "number_of_shipping_labels": null,
                    "attachment_url": null,
                    "detrack_number": "DET2000001",
                    "status": "dispatched",
                    "tracking_status": "Info received",
                    "reason": null,
                    "last_reason": null,
                    "received_by_sent_by": null,
                    "note": null,
                    "carrier": null,
                    "pod_lat": "",
                    "pod_lng": "",
                    "pod_address": "",
                    "address_tracked_at": null,
                    "arrived_lat": null,
                    "arrived_lng": null,
                    "arrived_address": null,
                    "arrived_at": null,
                    "texted_at": null,
                    "called_at": null,
                    "serial_number": null,
                    "signed_at": null,
                    "photo_1_at": null,
                    "photo_2_at": null,
                    "photo_3_at": null,
                    "photo_4_at": null,
                    "photo_5_at": null,
                    "signature_file_url": null,
                    "photo_1_file_url": null,
                    "photo_2_file_url": null,
                    "photo_3_file_url": null,
                    "photo_4_file_url": null,
                    "photo_5_file_url": null,
                    "actual_weight": null,
                    "temperature": null,
                    "hold_time": null,
                    "payment_collected": null,
                    "auto_reschedule": null,
                    "actual_crates": null,
                    "actual_pallets": null,
                    "actual_utilization": null,
                    "goods_service_rating": null,
                    "driver_rating": null,
                    "customer_feedback": null,
                    "eta_time": null,
                    "live_eta": null,
                    "depot": null,
                    "depot_contact": null,
                    "department": null,
                    "sales_person": null,
                    "identification_number": null,
                    "bank_prefix": null,
                    "run_number": null,
                    "pick_up_from": null,
                    "pick_up_time": null,
                    "pick_up_lat": null,
                    "pick_up_lng": null,
                    "pick_up_address": null,
                    "pick_up_address_1": null,
                    "pick_up_address_2": null,
                    "pick_up_address_3": null,
                    "pick_up_city": null,
                    "pick_up_state": null,
                    "pick_up_country": null,
                    "pick_up_postal_code": null,
                    "pick_up_zone": null,
                    "pick_up_assign_to": null,
                    "pick_up_reason": null,
                    "info_received_at": "2018-06-14T06:04:06.017Z",
                    "pick_up_at": null,
                    "scheduled_at": null,
                    "at_warehouse_at": null,
                    "out_for_delivery_at": null,
                    "head_to_pick_up_at": null,
                    "head_to_delivery_at": null,
                    "cancelled_at": null,
                    "pod_at": null,
                    "pick_up_failed_count": null,
                    "deliver_failed_count": null,
                    "job_price": null,
                    "insurance_price": null,
                    "insurance_coverage": false,
                    "total_price": null,
                    "payer_type": null,
                    "remarks": null,
                    "items_count": 2,
                    "service_type": null,
                    "warehouse_address": null,
                    "destination_time_window": null,
                    "door": null,
                    "time_zone": null,
                    "vehicle_type": null,
                    "created_at": "2018-06-14T06:04:06.017Z",
                    "items": [{
                        "id": "5b22055510c92b1a046ece05",
                        "sku": "12345678",
                        "purchase_order_number": null,
                        "batch_number": null,
                        "expiry_date": null,
                        "description": null,
                        "comments": null,
                        "quantity": 10,
                        "unit_of_measure": null,
                        "checked": false,
                        "actual_quantity": null,
                        "inbound_quantity": null,
                        "unload_time_estimate": null,
                        "unload_time_actual": null,
                        "follow_up_quantity": null,
                        "follow_up_reason": null,
                        "rework_quantity": null,
                        "rework_reason": null,
                        "reject_quantity": 0,
                        "reject_reason": null,
                        "weight": null,
                        "serial_numbers": [],
                        "photo_url": null
                    }, {
                        "id": "5b22055510c92b1a046ece06",
                        "sku": "12387654",
                        "purchase_order_number": null,
                        "batch_number": null,
                        "expiry_date": null,
                        "description": null,
                        "comments": null,
                        "quantity": 5,
                        "unit_of_measure": null,
                        "checked": false,
                        "actual_quantity": null,
                        "inbound_quantity": null,
                        "unload_time_estimate": null,
                        "unload_time_actual": null,
                        "follow_up_quantity": null,
                        "follow_up_reason": null,
                        "rework_quantity": null,
                        "rework_reason": null,
                        "reject_quantity": 0,
                        "reject_reason": null,
                        "weight": null,
                        "serial_numbers": [],
                        "photo_url": null
                    }],
                    "milestones": [{
                        "status": "info_recv",
                        "assign_to": null,
                        "reason": null,
                        "pod_at": "2018-06-14T06:04:06.017Z",
                        "created_at": "2018-06-14T06:04:06.017Z",
                        "user_name": "Simon"
                    }]
                }
            }

## Delete Job By DO [/dn/jobs/delete{?do_number}{?date}{?type}]

### Delete [DELETE]

+ Parameters

    + do_number: `12345678` (string, required) - Job DO number to be retrieved.
    + date: `2021-04-09` (string, optional) - Date of job.
    + type: `Delivery` (string, optional) - Detrack Job Type to be retrieved. Must be `Delivery` or `Collection`.

+ Request (application/json)

    + Headers

            X-API-KEY: {API_KEY}

+ Response 204 (application/json)


## Retrieve / Update / Delete by DO [/dn/jobs/{do_number}{?type}]

### Retrieve [GET]

+ Parameters

    + type: `Delivery` (string, optional) - Detrack Job Type to be retrieved. Must be `Delivery` or `Collection`.

+ Request (application/json)

    + Headers

            X-API-KEY: {API_KEY}

+ Response 200 (application/json)

    + Body

            {
                "data": {
                    "id": "5b22055510c92b1a046ece04",
                    "type": "Delivery",
                    "primary_job_status": "dispatched",
                    "open_to_marketplace": false,
                    "marketplace_offer": null,
                    "do_number": "DO 0",
                    "attempt": 1,
                    "date": "2018-06-14",
                    "start_date": "2018-06-14",
                    "job_age": 1,
                    "job_release_time": null,
                    "job_time": null,
                    "time_window": null,
                    "job_received_date": null,
                    "tracking_number": "T0",
                    "order_number": "ORN12345678",
                    "job_type": null,
                    "job_sequence": null,
                    "job_fee": null,
                    "address_lat": null,
                    "address_lng": null,
                    "address": "Singapore 470140",
                    "company_name": null,
                    "address_1": null,
                    "address_2": null,
                    "address_3": null,
                    "postal_code": "470140",
                    "city": null,
                    "state": null,
                    "country": null,
                    "geocoded_lat": 1.33668219002454,
                    "geocoded_lng": 103.910711702473,
                    "billing_address": null,
                    "deliver_to_collect_from": "James Li",
                    "last_name": null,
                    "phone_number": "65432178",
                    "sender_phone_number": null,
                    "fax_number": "65432179",
                    "instructions": null,
                    "assign_to": null,
                    "notify_email": "test@example.com",
                    "webhook_url": null,
                    "zone": null,
                    "customer": null,
                    "account_number": null,
                    "job_owner": null,
                    "invoice_number": null,
                    "invoice_amount": null,
                    "payment_mode": null,
                    "payment_amount": null,
                    "group_name": null,
                    "vendor_name": null,
                    "shipper_name": null,
                    "source": null,
                    "weight": null,
                    "parcel_width": null,
                    "parcel_length": null,
                    "parcel_height": null,
                    "cubic_meter": null,
                    "boxes": null,
                    "cartons": null,
                    "pieces": null,
                    "envelopes": null,
                    "pallets": null,
                    "bins": null,
                    "trays": null,
                    "bundles": null,
                    "rolls": null,
                    "number_of_shipping_labels": null,
                    "attachment_url": null,
                    "detrack_number": "DET2000001",
                    "status": "dispatched",
                    "tracking_status": "Info received",
                    "reason": null,
                    "last_reason": null,
                    "received_by_sent_by": null,
                    "note": null,
                    "carrier": null,
                    "pod_lat": "",
                    "pod_lng": "",
                    "pod_address": "",
                    "address_tracked_at": null,
                    "arrived_lat": null,
                    "arrived_lng": null,
                    "arrived_address": null,
                    "arrived_at": null,
                    "texted_at": null,
                    "called_at": null,
                    "serial_number": null,
                    "signed_at": null,
                    "photo_1_at": null,
                    "photo_2_at": null,
                    "photo_3_at": null,
                    "photo_4_at": null,
                    "photo_5_at": null,
                    "signature_file_url": null,
                    "photo_1_file_url": null,
                    "photo_2_file_url": null,
                    "photo_3_file_url": null,
                    "photo_4_file_url": null,
                    "photo_5_file_url": null,
                    "actual_weight": null,
                    "temperature": null,
                    "hold_time": null,
                    "payment_collected": null,
                    "auto_reschedule": null,
                    "actual_crates": null,
                    "actual_pallets": null,
                    "actual_utilization": null,
                    "goods_service_rating": null,
                    "driver_rating": null,
                    "customer_feedback": null,
                    "eta_time": null,
                    "live_eta": null,
                    "depot": null,
                    "depot_contact": null,
                    "department": null,
                    "sales_person": null,
                    "identification_number": null,
                    "bank_prefix": null,
                    "run_number": null,
                    "pick_up_from": null,
                    "pick_up_time": null,
                    "pick_up_lat": null,
                    "pick_up_lng": null,
                    "pick_up_address": null,
                    "pick_up_address_1": null,
                    "pick_up_address_2": null,
                    "pick_up_address_3": null,
                    "pick_up_city": null,
                    "pick_up_state": null,
                    "pick_up_country": null,
                    "pick_up_postal_code": null,
                    "pick_up_zone": null,
                    "pick_up_assign_to": null,
                    "pick_up_reason": null,
                    "info_received_at": "2018-06-14T06:04:06.017Z",
                    "pick_up_at": null,
                    "scheduled_at": null,
                    "at_warehouse_at": null,
                    "out_for_delivery_at": null,
                    "head_to_pick_up_at": null,
                    "head_to_delivery_at": null,
                    "cancelled_at": null,
                    "pod_at": null,
                    "pick_up_failed_count": null,
                    "deliver_failed_count": null,
                    "job_price": null,
                    "insurance_price": null,
                    "insurance_coverage": false,
                    "total_price": null,
                    "payer_type": null,
                    "remarks": null,
                    "items_count": 2,
                    "service_type": null,
                    "warehouse_address": null,
                    "destination_time_window": null,
                    "door": null,
                    "time_zone": null,
                    "vehicle_type": null,
                    "created_at": "2018-06-14T06:04:06.017Z",
                    "items": [{
                        "id": "5b22055510c92b1a046ece05",
                        "sku": "12345678",
                        "purchase_order_number": null,
                        "batch_number": null,
                        "expiry_date": null,
                        "description": null,
                        "comments": null,
                        "quantity": 10,
                        "unit_of_measure": null,
                        "checked": false,
                        "actual_quantity": null,
                        "inbound_quantity": null,
                        "unload_time_estimate": null,
                        "unload_time_actual": null,
                        "follow_up_quantity": null,
                        "follow_up_reason": null,
                        "rework_quantity": null,
                        "rework_reason": null,
                        "reject_quantity": 0,
                        "reject_reason": null,
                        "weight": null,
                        "serial_numbers": [],
                        "photo_url": null
                    }, {
                        "id": "5b22055510c92b1a046ece06",
                        "sku": "12387654",
                        "purchase_order_number": null,
                        "batch_number": null,
                        "expiry_date": null,
                        "description": null,
                        "comments": null,
                        "quantity": 5,
                        "unit_of_measure": null,
                        "checked": false,
                        "actual_quantity": null,
                        "inbound_quantity": null,
                        "unload_time_estimate": null,
                        "unload_time_actual": null,
                        "follow_up_quantity": null,
                        "follow_up_reason": null,
                        "rework_quantity": null,
                        "rework_reason": null,
                        "reject_quantity": 0,
                        "reject_reason": null,
                        "weight": null,
                        "serial_numbers": [],
                        "photo_url": null
                    }],
                    "milestones": [{
                        "status": "info_recv",
                        "assign_to": null,
                        "reason": null,
                        "pod_at": "2018-06-14T06:04:06.017Z",
                        "created_at": "2018-06-14T06:04:06.017Z",
                        "user_name": "Simon"
                    }]
                }
            }

### Update [PUT]

+ Parameters

    + type: `Delivery` (string, optional) - Detrack Job Type to be updated. Must be `Delivery` or `Collection`.

+ Request (application/json)

    + Headers

            X-API-KEY: {API_KEY}

    + Body

            {
                "data": {
                    "type": "Delivery",
                    "primary_job_status": "dispatched",
                    "open_to_marketplace": false,
                    "marketplace_offer": null,
                    "do_number": "DO 0",
                    "attempt": 1,
                    "date": "2018-06-14",
                    "start_date": "2018-06-14",
                    "job_age": 1,
                    "job_release_time": null,
                    "job_time": null,
                    "time_window": null,
                    "job_received_date": null,
                    "tracking_number": "T0",
                    "order_number": "ORN12345678",
                    "job_type": null,
                    "job_sequence": null,
                    "job_fee": null,
                    "address_lat": null,
                    "address_lng": null,
                    "address": "Singapore 470140",
                    "company_name": null,
                    "address_1": null,
                    "address_2": null,
                    "address_3": null,
                    "postal_code": "470140",
                    "city": null,
                    "state": null,
                    "country": null,
                    "billing_address": null,
                    "deliver_to_collect_from": "James Li",
                    "last_name": null,
                    "phone_number": "65432178",
                    "sender_phone_number": null,
                    "fax_number": "65432179",
                    "instructions": null,
                    "assign_to": null,
                    "notify_email": "test@example.com",
                    "webhook_url": null,
                    "zone": null,
                    "customer": null,
                    "account_number": null,
                    "job_owner": null,
                    "invoice_number": null,
                    "invoice_amount": null,
                    "payment_mode": null,
                    "payment_amount": null,
                    "group_name": null,
                    "vendor_name": null,
                    "shipper_name": null,
                    "source": null,
                    "weight": null,
                    "parcel_width": null,
                    "parcel_length": null,
                    "parcel_height": null,
                    "cubic_meter": null,
                    "boxes": null,
                    "cartons": null,
                    "pieces": null,
                    "envelopes": null,
                    "pallets": null,
                    "bins": null,
                    "trays": null,
                    "bundles": null,
                    "rolls": null,
                    "number_of_shipping_labels": null,
                    "attachment_url": null,
                    "detrack_number": "DET2000001",
                    "status": "dispatched",
                    "tracking_status": "Info received",
                    "reason": null,
                    "last_reason": null,
                    "received_by_sent_by": null,
                    "note": null,
                    "carrier": null,
                    "pod_lat": "",
                    "pod_lng": "",
                    "pod_address": "",
                    "address_tracked_at": null,
                    "arrived_lat": null,
                    "arrived_lng": null,
                    "arrived_address": null,
                    "arrived_at": null,
                    "texted_at": null,
                    "called_at": null,
                    "serial_number": null,
                    "signed_at": null,
                    "photo_1_at": null,
                    "photo_2_at": null,
                    "photo_3_at": null,
                    "photo_4_at": null,
                    "photo_5_at": null,
                    "signature_file_url": null,
                    "photo_1_file_url": null,
                    "photo_2_file_url": null,
                    "photo_3_file_url": null,
                    "photo_4_file_url": null,
                    "photo_5_file_url": null,
[...]
